// StringExtras.h | by Doug Manley
// StringExtras is a collection of functions and such to aid using std::strings.
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
#ifndef STRINGEXTRAS_H
#define STRINGEXTRAS_H
///////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string>
///////////////////////////////////////////////////////////////////
using namespace std;
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
string Str( int i );

int ToInt( const string &str );
bool ToBool( const string &str );

bool StringsAreEqual_IgnoreCase( string &str1, string &str2 );
bool StringsAreEqual_IgnoreCase( string &str1, char *str2 );
bool StringsAreEqual_IgnoreCase( char *str1, string &str2 );

bool IsCharacter( char c );

string GetLastFolderOfPath( string strPath );

string ToUpper( string str );
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
/* This function converts an integer to a String.
   Parameters:
      int i: the integer to convert.
   Returns:
      The new String.
*/
string Str( int i ) {
	string str;
	char tmp[12];
		itoa( i,tmp,10 );
	str = tmp;
	return(str);
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
/* This function converts a String to an integer.  It converts
   until it reaches a non-integer value in the string.
   Parameters:
	   String &str: the String to convert.
   Returns:
		The new integer.
*/
int ToInt( const string &str ) {
	int integer = 0;
	for( int i = 0; i < str.length(); i++ ) {
		if( str[i] >= '0' && str[i] <= '9' ) {
			integer *= (10);
			integer += (str[i]-'0');
		} else {
			break;
		}
	}
	return( integer );
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
/* This function converts a String to a boolean.  If the String is
   "yes" or "true" (ignoring case), it returns true. Otherwise, it
	returns false.
	Parameters:
	   String &str: the String to convert.
	Returns:
	   The boolean equivalent of the String.
*/
bool ToBool( const string &str ) {
	if( StringsAreEqual_IgnoreCase((string)str,"yes") ||
		 StringsAreEqual_IgnoreCase((string)str,"true") ) {
		return( true );
	} else {
		return(false);
	}
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
/* This function tests to see if two Strings are equal, ignoring
   their cases (capital/lowercase).
*/
bool StringsAreEqual_IgnoreCase( string &str1, string &str2 ) {
	if( str1.length() != str2.length() ) {
		return( false );
	}
	for( int i = 0; i < str1.length(); i++ ) {
		if( str1[i] == str2[i] ) {
			continue;
		}
		if( str1[i] >= 97 && str1[i] <= 122 ) {
			if( str2[i] == str1[i]-32 ) {
				continue;
			}
		}
		if( str2[i] >= 97 && str2[i] <= 122 ) {
			if( str1[i] == str2[i]-32 ) {
				continue;
			}
		}
		return( false );
	}
	return( true );
}
bool StringsAreEqual_IgnoreCase( string &str1, char *str2 ) {
	return( StringsAreEqual_IgnoreCase( str1, string(str2) ) );
}
bool StringsAreEqual_IgnoreCase( char *str1, string &str2 ) {
	return( StringsAreEqual_IgnoreCase( string(str1), str2 ) );
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
/* This function checks to see if a char is in the valid range for
   English text, including punctuation. */
bool IsCharacter( char c ) {
	if( c >= '!' && c <= '~' ) {
		return( true );
	} else {
		return( false );
	}
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
/* Returns the last folder in a path. */
string GetLastFolderOfPath( string strPath ) {
	int lastslash = strPath.find_last_of('\\');
	if( lastslash == -1 ) {
		return( strPath );
	} else {
		return( strPath.substr(lastslash+1) );
	}
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
/* Returns the uppercase version of the string. */
string ToUpper( string str ) {
	for( int i = 0; i < str.length(); i++ ) {
		if( str[i] >= 'a' && str[i] <= 'z' ) {
			str[i] -= 32;
		}
	}
	return(str);
}
/* Returns the lowercase version of the string. */
string ToLower( string str ) {
	for( int i = 0; i < str.length(); i++ ) {
		if( str[i] >= 'A' && str[i] <= 'Z' ) {
			str[i] += 32;
		}
	}
	return(str);
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////////////